/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   GSLBlock.h
 * Author: skidmarks
 *
 * Created on December 15, 2017, 2:53 PM
 */

#ifndef GSLBLOCK_H
#define GSLBLOCK_H

# include <gsl/gsl_block.h>

#include <gsl/gsl_block_double.h>

# include "GLSData.h"

using namespace std;

namespace gls {
   
class GSLBlock : GLSData {
private:
public:
   GSLBlock(size_t size);
   virtual ~GSLBlock()              { };
   virtual int fscanf(FILE stream, gsl_block b);
   virtual string toString();
   virtual void*  data()                        { return ((gsl_block*)strct())->data; }
   virtual double max()                         {  /* error */ return 0.0;};
   virtual double min()                         {  /* error */ return 0.0;};
   
   virtual int    isneg()                       {  /* error */ return 0;};
   virtual int    isnonneg()                    {  /* error */ return 0;};
   virtual int    isnull()                      {  /* error */ return 0;};
   virtual int    ispos()                       {  /* error */ return 0;};
   
   virtual double* ptr(size_t row, size_t col = 0) {  /* error */ return NULL;};
   virtual void   set(const double x, const size_t row, const size_t col = 0) {  /* error */};
   virtual void   set_zero()                    {  /* error */};
   virtual void   set_all(double x)             { /* error */ };
   
   virtual const double* const_ptr(size_t row, size_t col = 0)  { /* error */ return NULL; };
   virtual double get(const size_t row, const size_t col = 0)   { /* error */ return 0.0; };

   virtual int add(GLSData& b)                  {  /* error */ return 1;};
   virtual int add_constant(const double x)     {  /* error */ return 1;};
   virtual int sub(GLSData& b)                  {  /* error */ return 1;};

   virtual int memcpy(GLSData& dest)            {  /* error */ return 1;};
   
   virtual int scale(const double x)            {  /* error */ return 1;};
   
private:
   GSLBlock(const GSLBlock& orig);
}; // class GSLBlock

} // namespace gls
#endif /* GSLBLOCK_H */

